c
c     ! Mask variables
c

c     ! Maximum number of masks anticipated:
      integer     max_num_masks
      parameter ( max_num_masks  =  2 )

c     ! Masking constants:
      integer     BHMASK_UNMASKED
      integer     BHMASK_MASKED
      integer     BHMASK_REPOPULATE
      parameter ( BHMASK_UNMASKED      =  +1  )
      parameter ( BHMASK_MASKED        =  -1  )
      parameter ( BHMASK_REPOPULATE    =  +10 )

c     ! Number of masks in use at runtime:
      integer     num_masks

c     ! existence or not of a inflow boundary
      logical bh_true(max_num_masks)
 
      !
      ! For determining if it is time to 
      ! do the mask:
      !
      integer     mask_level, mask_iteration

c     !
c     ! Parameterization of the mask locations:
c     !  NB: likely to change when we have horizon finder
c     !  NB: the three is for the up-to-three coordinates
c     !    
      real(kind=8) mask_center(3,max_num_masks)
      real(kind=8) mask_radius(3,max_num_masks)
      real(kind=8) mask_left(3,max_num_masks)
      real(kind=8) mask_right(3,max_num_masks)
      real(kind=8) local_left(3,max_num_masks)
      real(kind=8) local_right(3,max_num_masks)

c     !
c     ! Store the coordinates of what is actually
c     ! excised...separate from what the finder
c     ! *wants* excised. Store (minx,max,miny,maxy...)
c     !
      real(kind=8) mask_coords(6,max_num_masks)

c     !
c     !  Memory to store old masks
c     !     (no need to store in common block)
c     !
      real(kind=8) old_mask_center(3,max_num_masks)
      real(kind=8) old_mask_radius(1,max_num_masks)

c     ! Fuzz-factor so that different levels
c     ! agree on whether a point is in the mask or not
      real(kind=8)  FUZZ
      parameter   ( FUZZ = 1.d-9 )


      common      / mask_common /
     *              mask_coords,
     *              mask_center,
     *              mask_radius,
     *              mask_left,
     *              mask_right,
     *              local_left,
     *              local_right,
     *              num_masks,
     *              mask_level,
     *              mask_iteration,
     *              bh_true
