#include "cctk.h"

!--------------------------------------------------------------------
!
!$Id: analysis.f90,v 1.2 2005/11/23 21:37:46 carlos Exp $
!
!--------------------------------------------------------------------

module mod_analysis
use params
use initial

implicit none
CONTAINS

  subroutine analysis_pt(u_pt, u0_pt, dxu_pt, dyu_pt, dzu_pt, &
                         v_pt , dxv_pt, dyv_pt, dzv_pt, w_pt, par)
    implicit none
    CCTK_REAL, dimension(NU), intent(inout)  :: u_pt,u0_pt,dxu_pt,dyu_pt,dzu_pt
    CCTK_REAL, dimension(NV), intent(inout)  :: v_pt,dxv_pt,dyv_pt,dzv_pt
    CCTK_REAL, dimension(NW), intent(in)     :: w_pt
    CCTK_REAL, dimension(NPAR),intent(inout) :: par

    return
  end subroutine

!--------------------------------------------------------------------
!
!
!--------------------------------------------------------------------
   subroutine analysis(u2, u0, dxu, dyu, dzu, v, dxv, dyv, dzv, w, par)
   use GF
   
   type(gridfunction), dimension(NV) :: v, dxv, dyv, dzv
   type(gridfunction), dimension(NU) :: u2, u0, dxu, dyu, dzu
   type(gridfunction), dimension(NW) :: w
   CCTK_REAL, dimension(:)           :: par

   !! local vars
   logical, parameter                :: ltrace  = .true.
   logical, parameter                :: ltrace2 = .false.

   CCTK_INT                          :: i, j, k, nx, ny, nz
   CCTK_REAL                         :: x, y, z

   if (ltrace2) write(0,*)'ANALYSIS: begin'

   nx = nint(par(P_NX))
   ny = nint(par(P_NY))
   nz = nint(par(P_NZ))
   
   if (ltrace2) write(0,*)'ANALYSIS: calculate residual'

   ! calculate the residual
   do k = 1, nz; do j = 1, ny; do i = 1, nx
      x = w(H_XPHYS)%d(i,j,k)
      y = w(H_YPHYS)%d(i,j,k)
      z = w(H_ZPHYS)%d(i,j,k)
      
      
   end do; end do; end do

    return
 end subroutine analysis

 end module mod_analysis
