#include "cctk.h"


module HYPER_BOUNDARY
   use params
   use GF
   use m_char_boundary
   implicit none

   contains 

!---------------------------------------------------------------------------
!
!  Some comments: what is called u in this subroutine is actually 
!  u or u_dot, depending on whether we are giving boundary conditions 
!  to the rhs or the vars.
!
!____________________________________________________________________________

  subroutine hyperboundary(u, dxu, dyu, dzu, udot, v, w, imask, par)
    
    type(gridfunction), dimension(NU), intent(inout) :: u, dxu,dyu,dzu,udot
    type(gridfunction), dimension(NV) :: v
    type(gridfunction), dimension(NW) :: w
    CCTK_REAL, dimension(:)           :: par
    CCTK_INT, dimension(:,:,:)        :: imask
    
    logical, parameter :: ltrace = .false.


    if (ltrace) write(*,*)' @@@@@  hyperboundary '

    call char_boundary(u, dxu, dyu, dzu, udot, v, w, imask, par)

    return
  end subroutine hyperboundary

end module HYPER_BOUNDARY
